void main()
{    /*
    * Caskey, Damon V.
    * 2022-01-26
    *
    * Example function to enumerate the entity
    * collection and take action on each
    * if they meet specfifc conditions.
    */
    void entity_cursor    = NULL();
    int entity_count    = openborvariant("count_entities");
    int entity_index    = 0;
    int exists            = 0;

    /*
    * This loop runs on every entity in play.
    * It works by iterating from 0 to <entity count>.
    * At each iteration it gets an entity using the
    * index cursor, verifies its existence, and then
    * runs some custom checks.
    *
    * If any check fails, the loop skips and
    * moves on to the next iteration. If all the
    * checks pass, it runs whatever action code
    * you place inside of it. The best practice
    * is to put your action code into another
    * function and let the loop execute that.
    */

    for(entity_index = 0; entity_index < entity_count; entity_index++){
        /*
        * Get target entity for this loop increment,
        * verify it is a valid pointer, and make
        * sure it exists in play. The last check
        * appears redundant, but it's possible for
        * an entity to be removed while its pointer
        * is still valid.
        */

        entity_cursor = getentity(entity_index);

        if(!entity_cursor){
            continue;
        }

        exists = getentityproperty(entity_cursor, "exists");

        if(!exists){
            continue;
        }

        /*
        * Check for specific conditions to your module here.
        * This example skips non-enemy types.
        */

        if( getentityproperty(entity_cursor, "type") != openborconstant("TYPE_ENEMY")){
            
            continue;
        }

        if( getentityproperty(entity_cursor, "animationID") != openborconstant("ANI_IDLE")&&
            getentityproperty(entity_cursor, "animationID") != openborconstant("ANI_WALK")&&
            getentityproperty(entity_cursor, "animationID") != openborconstant("ANI_RUN")){
            
            //RESET ONLY THE DELAY VALUE FOR ALL ANIMATIONS DIFFERENT OF THE LISTED ABOVE
            changeentityproperty(entity_cursor, "edelay", 1, 1, 1, 100, 1, 100);
            continue;
        }

        float speed    = getentityproperty(entity_cursor, "speed");
        float reduce   = 0.1;
        int delay      = 4;
        int noAtk      = 9999999999;

        //THIS IS THE ANIMATION THAT WILL ACTIVATE THE SLOWDOWN AND DISABLE ATTACK EFFECT
        if(getentityvar(entity_cursor, "slow") == NULL()){
            changeentityproperty(entity_cursor, "speed", reduce); //APPLY SPEED REDUCTION
            changeentityproperty(entity_cursor, "running", reduce*2); //APPLY RUNNING REDUCTION
            changeentityproperty(entity_cursor, "jumpspeed", reduce*2); //APPLY JUMP SPEED REDUCTION
            changeentityproperty(entity_cursor, "edelay", 1, delay, 1, 100, 1, 100); //INCREASE DELAY VALUE
            changeentityproperty(entity_cursor, "attackthrottle", noAtk); //SET A HIGH VALUE TO DISABLE ATTACKS
            changeentityproperty(entity_cursor, "attackthrottletime", noAtk); //SET A HIGH VALUE TO DISABLE ATTACKS
            setentityvar(entity_cursor, "slow", 1);
        }
    }
}